/*   
 *   CATMA Computer Aided Text Markup and Analysis
 *   
 *   Copyright (C) 2009  University Of Hamburg
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

package de.catma.serialization.tei;


/**
 * TEI elements used by CATMA.<br><br>
 * 
 * see <a href="http://www.tei-c.org/release/doc/tei-p5-doc/en/html/index.html">
 * TEI P5 Reference</a>
 *
 * @author Marco Petris
 *
 */
public enum TeiElementName {
	ab, p, TEI, teiHeader, fileDesc, 
	titleStmt, title, author, publisher, sourceDesc, f, fs, 
	string, numeric, ptr, body, fvLib, seg, text, div,
	encodingDesc, appInfo, application, label,
    language, langUsage, profileDesc, vColl, timeline, when, u, 
    fsdDecl, fsDecl, fsDescr, fDecl, vRange;
}
