/*   
 *   CATMA Computer Aided Text Markup and Analysis
 *   
 *   Copyright (C) 2009-2013  University Of Hamburg
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.catma.ui.module.annotate;

import java.io.IOException;

import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.ObjectNode;

import de.catma.ui.client.ui.tagger.shared.ClientTagDefinition;

public class ClientTagDefinitionJSONSerializer {

	public String toJSON(ClientTagDefinition clientTagDefinition) 
			throws IOException {
		return toJSONObject(clientTagDefinition).toString();
	}

	private ObjectNode toJSONObject(ClientTagDefinition clientTagDefinition) 
			throws IOException {
		JsonNodeFactory factory = JsonNodeFactory.instance;
		ObjectNode result = factory.objectNode();
		result.put(
			ClientTagDefinition.SerializationField.tagDefinitionID.name(), 
			clientTagDefinition.getId());
		result.put(
			ClientTagDefinition.SerializationField.colorHexValue.name(),
			clientTagDefinition.getColor());
		return result;
	}
}
